<?php
#注册插件
RegisterPlugin("Bdpush_lazy","ActivePlugin_Bdpush_lazy");

function ActivePlugin_Bdpush_lazy() {
	global $zbp;
	Add_Filter_Plugin('Filter_Plugin_Index_Begin','Bdpush_lazy_Main');
	Add_Filter_Plugin('Filter_Plugin_Edit_Response3', 'Bdpush_lazy_response3');
	Add_Filter_Plugin('Filter_Plugin_PostArticle_Succeed', 'Bdpush_lazy_succeed');
	
}

function Bdpush_lazy_SubMenu($id) {
	$aryCSubMenu = array(	
		0 => array('基础配置', '?suc=set', 'set', 'left', false),		
		1 => array('Sitemap地图', '?suc=bdmap', 'bdmap', 'left', false),	
		2 => array('一键推送', '?suc=tuisong', 'tuisong', 'left', false),
		3 => array('链接提交', '?suc=kssl', 'kssl', 'left', false),
		4 => array('Robots文件', '?suc=robots', 'robots', 'left', false),
		5 => array('定时推送', '?suc=dsts', 'zdts', 'left', false),			
		6 => array('帮助', 'http://www.newbii.cn/', '', 'right', true)
	);
	foreach($aryCSubMenu as $k => $v) {
		echo '<a href="' . $v[1] . '" ' . ($v[4] == true ? 'target="_blank"' : '').'><span class="m-' . $v[3] . ' ' . (GetVars('suc') == $v[2] ? 'm-now' : '') . '">' . $v[0] . '</span></a>';
	}
}

function Bdpush_lazy_Main() {
	global $zbp;
    if( strpos($zbp->currenturl,'Bdpush_lazy_sitemap') !==false ) {
    	$strs = explode('_',$zbp->currenturl);
    	$last = array_pop($strs);
        Bdpush_lazy_sitemap();
        die();
    }
}

function Bdpush_lazy_succeed(&$article) {
	global $zbp;
    $urls = $article->Url;   
    $api = $zbp->Config('Bdpush_lazy')->bdapi;
	if ($zbp->Config('Bdpush_lazy')->huochetou == '1') {
        Bdpush_lazy_ajax($urls);
	}
	if (GetVars('BaiduTuis', 'POST') != '1' && GetVars('KSTuis', 'POST') != '1') {
		return;
	}
	if (GetVars('Status', 'POST') > 0) {
		return;
	}
	if (GetVars('BaiduTuis', 'POST')== '1') {
        $ajax = Bdpush_lazy_ajax($urls);
		$zbp->SetHint('good','普通收录状态:'.$ajax);
	}
	if (GetVars('KSTuis', 'POST')== '1') {
        $ajax = Bdpush_lazy_ajax($urls, $api . '&type=daily');
		$zbp->SetHint('good','快速收录状态:'.$ajax);
	}
}

function Bdpush_lazy_response3() {
	?>
    <div id="BaiduTuis" class="editmod">
    <input type="checkbox" name="BaiduTuis" value="1" checked="checked" /><span class="tips">百度普通收录</span>
    </div>
    <div id="KSTuis" class="editmod">
    <input type="checkbox" name="KSTuis" value="1" /><span class="tips" style="color: red;">快速收录</span>
    </div>
<?php
}

function Bdpush_lazy_sitemap($nums = null, $page =null, $type = null, $makefile = false) {
	global $zbp;  
    $strs = explode('_',$zbp->currenturl);
	$module = explode(".",array_pop($strs));
    if($page == null) {
        preg_match("/[a-zA-Z]+/", $module[0], $m);
        preg_match("/[0-9]+/", $module[0], $m1);
        $type = $m[0];
        $page = $m1[0];
    }
    $sitemap_nums = $zbp->Config('Bdpush_lazy')->sitemap_nums;
	$count = ceil($zbp->cache->all_article_nums / $zbp->Config('Bdpush_lazy')->sitemap_nums);
	
    $priority = $zbp->Config('Bdpush_lazy')->priority;
    $changefreq = $zbp->Config('Bdpush_lazy')->changefreq;
	$isxmlstyle = ($zbp->Config('Bdpush_lazy')->isxmlstyle == '1') ? $zbp->host.'zb_users/plugin/Bdpush_lazy/css/sitemap.xsl' : false;
	$json = Bdpush_lazy_getLink($type, $page, $sitemap_nums, null);
	$data = json_decode($json, true);
    if($module[1] == 'txt') {
    	header('Content-Type: text/plain');
        foreach ($data['Data'] as $article) {
            echo $article['url']."\r\n";
        }
    } elseif ($module[1] == 'xml') {
        require 'sitemap.class.php';
        $sitemap = new Bdpush_lazy_Sitemap($isxmlstyle);
        foreach ($data['Data'] as $article) {
            $sitemap->AddItem($article['url'], $priority, $article['time'], $changefreq);
        }
        $sitemap->Show();
    } else {
    	return ;
    }
}

function Bdpush_lazy_ajax($url, $api='') {      	    	         	       	   			
    global $zbp;
    $ajax = Network::Create();
    if(!$api){
        $api = trim($zbp->Config('Bdpush_lazy')->bdapi);
    }
    if(is_array($url)) {
    	$urls = $url;
    } else {
    	$urls[] = $url;
    }
    $ajax->open('POST', $api);
    $ajax->setTimeOuts(120, 120, 0, 0);
    $ajax->send(implode("\n", $urls));
    return $ajax->responseText;
}

function Bdpush_lazy_getLink($module, $page = 1, $nums = false, $ids = null) {
    global $zbp;
    $p = new Pagebar(null, false);
    if($nums) {
        $p->PageCount = $nums;
    } else {
        $p->PageCount = $zbp->managecount;
    }
    $p->PageNow = (int) $page == '' ? 1 : (int) $page;
    $p->PageBarCount = $zbp->pagebarcount;
    $w = array();
    $id = explode("x",$ids);
        
    $urls  = array();
    switch ($module) {
        case 'post':
            $w[] = array('=', 'log_Status', '0');
            if(isset($id[0])) {$w[] =  array('>=', 'log_ID', (int) $id[0]);}
            if(isset($id[1])) {$w[] =  array('<=', 'log_ID', (int) $id[1]);}
            $array = $zbp->GetArticleList('', $w, array('log_PostTime' => 'DESC'), array(($p->PageNow - 1) * $p->PageCount, $p->PageCount), array('pagebar' => $p));
            foreach ($array as $key=>$article) {
                $urls[$key]['url'] = $article->Url;
                $urls[$key]['time'] = $article->Time('Y-m-d');
            }
        break;
        case 'page':
            $w[] = array('=', 'log_Status', '0');
            if(isset($id[0])) {$w[] =  array('>=', 'log_ID', (int) $id[0]);}
            if(isset($id[1])) {$w[] =  array('<=', 'log_ID', (int) $id[1]);}
            $array = $zbp->GetPageList('', $w, array('log_PostTime' => 'DESC'), array(($p->PageNow - 1) * $p->PageCount, $p->PageCount), array('pagebar' => $p));
            foreach ($array as $key=>$article) {
                $urls[$key]['url'] = $article->Url;
                $urls[$key]['time'] = $article->Time('Y-m-d');
            }
        break;
        case 'category':
            if(isset($id[0])) {$w[] =  array('>=', 'cate_ID', (int) $id[0]);}
            if(isset($id[1])) {$w[] =  array('<=', 'cate_ID', (int) $id[1]);}
            $array = $zbp->GetCategoryList('', $w, array('cate_Order' => 'ASC'), array(($p->PageNow - 1) * $p->PageCount, $p->PageCount), array('pagebar' => $p));
            foreach ($array as $key=>$category) {
                $urls[$key]['url'] = $category->Url;
                $urls[$key]['time'] = '';
            }
        break;
        case 'tags':
            if(isset($id[0])) {$w[] =  array('>=', 'tag_ID', (int) $id[0]);}
            if(isset($id[1])) {$w[] =  array('<=', 'tag_ID', (int) $id[1]);}
            $array = $zbp->GetTagList('', $w, array('tag_ID' => 'ASC'), array(($p->PageNow - 1) * $p->PageCount, $p->PageCount), array('pagebar' => $p));
            foreach ($array as $key=>$tag) {
                $urls[$key]['url'] = $tag->Url;
                $urls[$key]['time'] = '';
            }
        break;
    }
    $data = array();
    $data['pageAll'] = $p->PageAll;
    $data['Data'] = $urls;
    return json_encode($data);
    
}

function InstallPlugin_Bdpush_lazy() {
	global $zbp; 
    if (!$zbp->Config('Bdpush_lazy')->HasKey('Version')) {
        $array = array(
            'Version'        => '2.2',
            'bdapi'          => '',
            'sitemap_nums'   => '500',
            'changefreq'     => 'always',
            'priority'       => '0.5',
            'networktype'    => '',
            'pwd'            => '',
            'mobile'         => '0',
            'huochetou'      => '0',
        );
        foreach ($array as $value => $intro) {
            $zbp->Config('Bdpush_lazy')->$value = $intro;
        }
        //$zbp->SaveConfig('Bdpush_lazy');
	}
	$zbp->Config('Bdpush_lazy')->Version = '2.3';
    $zbp->SaveConfig('Bdpush_lazy');
}