<?php

class Bdpush_lazy_push
{

    private  $module;
    private  $ids = null;
    private  $PageAll = 0;
    private  $urls = array();

    function __construct($module, $ids) {
        $this->module = $module;
        $this->ids = $ids;
        $this->get_data();
    }
    
    public function get_queue()
    {
        if ($this->PageAll>0) {
            for($i=1;$i<=$this->PageAll;$i++) {
                $this->set_queue('send_pushStatus', $i);
            }
        } else {
            $this->set_queue('send_msg', 'No this ID,Please check ID!');
        }
    }

    public function set_queue($function, $param)
    {
        $this->output_json[] = json_encode(array('type' => 'queue', 'function' => $function, 'param' => $param, 'error' => 0));
        return true;
    }
    
    public function output($status, $text, $title = '')
    {
        $string = '<span title= "' . $title . '" style="color:';
        $string .= ($status === 'success' ? 'green">√' : 'red">×') . ' ';
        $string .= $text . '</span>';
        $this->output_json[] = json_encode(array('type' => 'msg', 'msg' => $string, 'error' => $status));

        return $string;
    }
    
    public function send_msg($param)
    {
        $this->output('error', $param, $param);
    }
    
    public function send_pushStatus($param)
    {
        $this->get_data($param);
        $urls = $this->urls;
        $json_string = $this->push_link($urls);
        if (is_null(json_decode($json_string))) {
            exit('Please check you BaiDu API!');
        }
        $title = '';
        foreach ($urls as $key=>$url) {
            $title .= '<p>'.$url.'</p>';
            if($key>5) {
                $title .= '<p>... ...</p>'; 
                break;
            }
        }
        $data = json_decode($json_string, true);
        if(isset($data['success']) && $data['success'] > 0) {
        	$this->output('success', $json_string, $title);
        } else {
        	$this->output('error', $json_string, $title);
        }
        
    }
    
    public function get_data($page = 1)
    {
        global $zbp;
        $json = Bdpush_lazy_getLink($this->module, $page, $zbp->managecount, $this->ids);
        $data = json_decode($json, true);
        $urls = array();
        foreach ($data['Data'] as $a) {
            $urls[] = $a['url'];
        }
        $this->PageAll = $data['pageAll'];
        $this->urls = $urls;
        return true;
    }
    
    public function push_link($url, $api = null) {
    	global $zbp;
    	$ajax = Network::Create();
    	if(!$api){
    		$api = trim($zbp->Config('Bdpush_lazy')->bdapi);
    	}
    	if(is_array($url)) {
    		$urls = $url;
    	} else {
    		$urls[] = $url;
    	}
    	$ajax->open('POST', $api);
    	$ajax->setTimeOuts(120, 120, 0, 0);
    	$ajax->send(implode("\n", $urls));
    	return $ajax->responseText;
    }
    
}