<?php
require 'phpmailer/src/ExceptionXFEmail.php';
require 'phpmailer/src/SMTPXFEmail.php';
require 'phpmailer/src/PHPMailerXFEmail.php';

#注册插件
RegisterPlugin('XF_Email', 'ActivePlugin_XF_Email');

function send_xf_mail($address, $subject, $message)
{
    global $zbp;
    $mail = new PHPMailerXFEmail;
    $mail->IsSMTP();
    $mail->IsHTML(true);
    $mail->CharSet = 'UTF-8';
    $mail->AddAddress($address);
    $mail->Body = $message;
    $mail->From = $zbp->Config('XF_Email')->MAIL_SENDEMAIL;
    $mail->FromName = $zbp->Config('XF_Email')->MAIL_NAME;
    $mail->Subject = $subject;
    $mail->Host = $zbp->Config('XF_Email')->MAIL_SMTP;
    $Secure = $zbp->Config('XF_Email')->MAIL_Secure;
    $mail->SMTPSecure = empty($Secure) ? '' : $Secure;
    $port = $zbp->Config('XF_Email')->MAIL_PORT;
    $mail->Port = empty($port) ? "25" : $port;
    $mail->SMTPAuth = true;
    $mail->SMTPAutoTLS = false;
    $mail->Timeout = 10;
    $mail->Username = $zbp->Config('XF_Email')->MAIL_SENDEMAIL;
    $mail->Password = $zbp->Config('XF_Email')->MAIL_PASSWORD;
    if (!$mail->Send()) {
        $mailError = $mail->ErrorInfo;
        return ["error" => 1, "message" => $mailError];
    } else {
        return ["error" => 0, "message" => "success"];
    }
}

function XF_Email_Secure_Radio($int) {
    $value=array("","ssl","tls");
    foreach ($value as $key=>$article) {
        echo '<input name="MAIL_Secure" type="radio" value="'.$article.'"';
        if($value[$key]==$int){
            echo 'checked="checked"';
        }
        if(empty($value[$key])){
            echo '/>默认</label>';}
    	else{
            echo '/>'.$value[$key].'</label>';
        }
    }
}

function InstallPlugin_XF_Email() {
	global $zbp;
	if(!$zbp->Config('XF_Email')->HasKey('Version')) {
		$zbp->Config('XF_Email')->Version = '1';
		$zbp->Config('XF_Email')->MAIL_SMTP = 'smtp.139.com';
		$zbp->Config('XF_Email')->MAIL_PORT = '25';
		$zbp->Config('XF_Email')->MAIL_Secure = '';
		$zbp->Config('XF_Email')->MAIL_SENDEMAIL = 'admin@139.com';
		$zbp->Config('XF_Email')->MAIL_PASSWORD = '123456';
		$zbp->Config('XF_Email')->MAIL_NAME = 'XiaoFeng';
		$zbp->SaveConfig('XF_Email');
	}
}

function UninstallPlugin_XF_Email() {
	global $zbp;
	$zbp->DelConfig('XF_Email');
}
