<?php
#注册插件
RegisterPlugin("xiurr_code", "ActivePlugin_xiurr_code");


function ActivePlugin_xiurr_code()
{
    Add_Filter_Plugin('Filter_Plugin_Edit_Response3', 'xiurr_code_Response3');
    Add_Filter_Plugin('Filter_Plugin_ViewPost_Template', 'xiurr_code_main');
    // Add_Filter_Plugin('Filter_Plugin_Html_Js_ZbpConfig', 'xiurr_code_remove');
}

// 兼容性问题，编辑器在开启了代码高亮时，会造成样式冲突，在此移除掉
// 但非所有编辑器适用
// function xiurr_code_remove()
// {
//     $hook = ['ueditor_SyntaxHighlighter_print', 'ForeScript_Neditor', 'TinyMCE_Js_Add'];
//     foreach ($hook as $value) {
//         Remove_Filter_Plugin('Filter_Plugin_Html_Js_Add', $value);
//     }
// }

function xiurr_code_Response3()
{
    global $zbp;
    // 如果开启了UEditor编辑器，并且关闭了代码高亮，则在工具栏重新添加代码块功能
    if ($zbp->CheckPlugin('UEditor') && !$zbp->option['ZC_SYNTAXHIGHLIGHTER_ENABLE']) {
        echo '<script>window.UEDITOR_CONFIG["toolbars"][1].push("insertcode");</script>';
    }
}

function xiurr_code_main()
{
    global $zbp;

    $config = json_decode($zbp->Config('xiurr_code')->config, true);
    $v      = $zbp->Config('xiurr_code')->version;

    $zbp->header .= '<link rel="stylesheet" href="' . $zbp->host . 'zb_users/plugin/xiurr_code/assets/css/highlight/' . $config['highlight_style'] . '">';
    $zbp->header .= '<link rel="stylesheet" href="' . $zbp->host . 'zb_users/plugin/xiurr_code/assets/css/xiurr_code.min.css?v=' . $v . '">';

    // 输出拓展样式
    if (!empty(trim($config['code_style']))) {
        $zbp->header .= '<style>' . $config['code_style'] . '</style>';
    }

    // 赋值配置信息
    $zbp->footer .= '<script>window.XIURR_CODE_CONFIG =' . $zbp->Config('xiurr_code')->config . '</script>';
    // 导入JS
    $zbp->footer .= '<script type="text/javascript" src="' . $zbp->host . 'zb_users/plugin/xiurr_code/assets/vendor/clipboard.min.js"></script>';
    $zbp->footer .= '<script type="text/javascript" src="' . $zbp->host . 'zb_users/plugin/xiurr_code/assets/vendor/highlight.min.js"></script>';
    $zbp->footer .= '<script type="text/javascript" src="' . $zbp->host . 'zb_users/plugin/xiurr_code/assets/js/xiurr_code.min.js?v=' . $v . '"></script>';
}

// 插件安装时
function InstallPlugin_xiurr_code()
{
    // 设置配置信息
    UpdateConfig_xiurr_code();
}

// 插件更新时
function UpdatePlugin_xiurr_code()
{
    // 设置配置信息
    UpdateConfig_xiurr_code();
}

// 插件卸载时
function UninstallPlugin_xiurr_code()
{
    global $zbp;
    // 删除配置
    $config = json_decode($zbp->Config('xiurr_code')->config, true);
    if (isset($config['keep_config']) && $config['keep_config'] === 'off') {
        $zbp->DelConfig('xiurr_code');
    }
}

// 设置配置信息
function UpdateConfig_xiurr_code()
{
    global $zbp;
    // 判断配置项是否存在
    if (!$zbp->HasConfig('xiurr_code')) {
        $zbp->Config('xiurr_code')->version     = 1.1;
        $zbp->Config('xiurr_code')->InstallTime = date('Y-m-d H:i:s');
        $zbp->Config('xiurr_code')->config      = json_encode([
            'border_style'      => 'mac-change-light', // 外观样式
            'highlight_style'   => 'base16/atelier-sulphurpool-light.min.css', // 高亮样式
            'show_shadow'       => 'show-shadow', // 外观阴影
            'show_type'         => 'show-type', // 代码类型
            'show_line'         => '', // 行数分割线
            'show_line_number'  => 'show-line-number', // 行数字
            'code_word_wrap'    => 'off', // 代码换行
            'code_group_btn'    => ['full' => 'on', 'copy' => 'on', 'close' => 'on'], // 显示按钮
            'code_close'        => 'off', // 是否默认处于折叠状态
            'code_height_limit' => 0, // 高度限制
            'code_limit_btn'    => 'off', // 是否显示展开按钮
            'code_style'        => '', // 拓展样式
            'keep_config'       => 'on', // 卸载时保留配置
        ], JSON_UNESCAPED_UNICODE);
        // 记得保存
        $zbp->SaveConfig('xiurr_code');
    } else {

        $new    = 1.1;
        $old    = $zbp->Config('xiurr_code')->version;
        $config = json_decode($zbp->Config('xiurr_code')->config, true);

        // 1.1 版本新增参数
        if ($old < 1.1) {
            // 新增参数
            $config['code_style']  = ''; // 拓展样式
            $config['keep_config'] = 'on'; // 卸载时保留配置
        }

        if ($old < $new) {
            $zbp->Config('xiurr_code')->version = $new;
            $zbp->Config('xiurr_code')->config  = json_encode($config, JSON_UNESCAPED_UNICODE);
            $zbp->SaveConfig('xiurr_code');
        }

    }
}

