<?php /* EL PSY CONGROO */
require '../../../zb_system/function/c_system_base.php';
require '../../../zb_system/function/c_system_admin.php';
$zbp->Load();
$action = 'root';
if (!$zbp->CheckRights($action)) {
    $zbp->ShowError(6);
    die();
}
if (!$zbp->CheckPlugin('xiurr_code')) {
    $zbp->ShowError(48);
    die();
}

$blogtitle = 'xiurr_code';
require $blogpath . 'zb_system/admin/admin_header.php';
require $blogpath . 'zb_system/admin/admin_top.php';

// 遍历highlight下所有主题文件，不会返回src
// [
//     [basename] => windows-high-contrast.min.css
//     [filename] => windows-high-contrast.min
//     [path] => base16/
// ]
function xiurr_code_get_list($src)
{
    $data   = GetFilesInDir_Recursive($src, 'css');
    $result = [];
    foreach ($data as $key => $value) {
        $info     = pathinfo($value);
        $path     = str_replace([$src . '/', $src], '', $info['dirname']);
        $result[] = [
            'basename' => $info['basename'],
            'filename' => $info['filename'],
            'path'     => empty($path) ? '' : $path . '/',
        ];
    }
    // 根据字段对数组进行降序排列
    $file_names = array_column($result, 'filename');
    array_multisort($file_names, SORT_ASC, $result);
    return $result;
}

// 获取高亮CSS列表
$list_name = xiurr_code_get_list("./assets/css/highlight");
// 获取配置文件
$xiurr_code_config = json_decode($zbp->Config('xiurr_code')->config, true);

?>

    <link rel="stylesheet" href="assets/vendor/layui/css/layui.css">
    <link rel="stylesheet" href="assets/css/highlight/<?php echo $xiurr_code_config['highlight_style']; ?>"
          id="xiurr_css_href">
    <link rel="stylesheet" href="assets/css/xiurr_code.css">
    <style>.layui-form-label {
            width: 100px;
            padding: 9px 10px 9px 0;
        }

        .layui-unselect.layui-form-switch, .layui-form-label {
            box-sizing: unset;
        }

        .layui-form-select dl {
            max-height: 500px;
        }

        .layui-form-select dl dt {
            font-size: 16px;
            font-weight: bold;
        }

        .dash-btn .layui-form-checkbox[lay-skin=primary] {
            margin-top: 0;
        }

        .dash-btn {
            border: 1px dashed #eee;
            box-sizing: border-box;
            padding: 5px;
            display: inline-block;
            margin-right: 10px;
            margin-top: 5px;
        }</style>

    <div id="divMain">
        <div class="divHeader"><span>多样式代码高亮插件</span></div>
        <div class="SubMenu" style="display: block;"></div>
        <div id="divMain2" class="layui-fluid">

            <div class="layui-row">
                <div class="layui-col-md6 layui-col-md-offset1">
                    <form class="layui-form" action="<?php echo BuildSafeURL("main.php?act=save"); ?>" method="post"
                          lay-filter="xiurr_code_form">
                        <?php if (function_exists('CheckIsRefererValid')) {
                            echo '<input type="hidden" name="csrfToken" value="' . $zbp->GetCSRFToken("xiurr_code") . '">';
                        }; ?>
                        <div class="layui-form-item">
                            <blockquote class="layui-elem-quote">
                                <h3 style="color: #FF5722">请先关闭系统的代码高亮、以及其他代码高亮插件，以免造成冲突！</h3>
                                系统代码高亮设置路径：网站设置 > 页面设置 > 代码高亮
                            </blockquote>
                        </div>
                        <div class="layui-form-item">
                            <label class="layui-form-label">外观样式</label>
                            <div class="layui-input-block">
                                <input lay-filter="border-style" type="radio" name="border_style" value="base-light"
                                       title="明亮">
                                <input lay-filter="border-style" type="radio" name="border_style" value="base-dark"
                                       title="暗黑">
                                <input lay-filter="border-style" type="radio" name="border_style" value="mac-light"
                                       title="苹果-明亮">
                                <input lay-filter="border-style" type="radio" name="border_style" value="mac-dark"
                                       title="苹果-暗黑">
                                <input lay-filter="border-style" type="radio" name="border_style"
                                       value="mac-change-light" title="苹果-导航栏变色明亮">
                                <input lay-filter="border-style" type="radio" name="border_style"
                                       value="mac-change-dark" title="苹果-导航栏变色暗黑">
                                <input lay-filter="border-style" type="radio" name="border_style" value="layui-light"
                                       title="layui-明亮">
                                <input lay-filter="border-style" type="radio" name="border_style" value="layui-dark"
                                       title="layui-暗黑">
                            </div>
                        </div>

                        <div class="layui-form-item">
                            <label class="layui-form-label">高亮样式</label>
                            <div class="layui-input-block" id="highlight-style-box">
                                <select name="highlight_style" lay-filter="highlight-style" id="highlight-style"
                                        lay-search>
                                </select>
                            </div>
                            <div class="layui-input-block layui-clear">
                                <div class="layui-form-mid layui-word-aux">点击下拉框，键盘上下键可直接选择样式，按Esc可还原点击下拉框前所选择的样式
                                </div>
                            </div>
                        </div>

                        <div class="layui-form-item">
                            <label class="layui-form-label">外观风格</label>
                            <div class="layui-input-block">
                                <input type="checkbox" name="show_shadow" title="显示阴影" lay-skin="primary"
                                       lay-filter="class_setting"
                                       value="show-shadow" <?php echo $xiurr_code_config['show_shadow'] == 'show-shadow' ? 'checked' : ''; ?>>
                            </div>
                        </div>
                        <div class="layui-form-item">
                            <label class="layui-form-label">显示按钮</label>
                            <ul class="dash-box layui-input-block"></ul>
                            <div class="layui-input-block layui-clear">
                                <div class="layui-form-mid layui-word-aux">勾选要展示的项目，可进行拖拽排序</div>
                            </div>
                        </div>

                        <div class="layui-form-item">
                            <label class="layui-form-label">代码风格</label>
                            <div class="layui-input-block">
                                <input type="checkbox" name="show_type" title="显示代码类型" lay-skin="primary"
                                       value="show-type"
                                       lay-filter="class_setting" <?php echo $xiurr_code_config['show_type'] == 'show-type' ? 'checked' : ''; ?>>
                                <input type="checkbox" name="show_line_number" title="显示行号" lay-skin="primary"
                                       value="show-line-number"
                                       lay-filter="class_setting" <?php echo $xiurr_code_config['show_line_number'] == 'show-line-number' ? 'checked' : ''; ?>>
                                <input type="checkbox" name="code_word_wrap" title="代码换行" lay-skin="primary"
                                       value="code-word-wrap"
                                       lay-filter="class_setting" <?php echo $xiurr_code_config['code_word_wrap'] == 'code-word-wrap' ? 'checked' : ''; ?>>
                                <input type="checkbox" name="show_line" title="行号分割" lay-skin="primary"
                                       value="show-line"
                                       lay-filter="class_setting" <?php echo $xiurr_code_config['show_line'] == 'show-line' ? 'checked' : ''; ?>>
                            </div>
                        </div>

                        <div class="layui-form-item">
                            <label class="layui-form-label">高度限制</label>
                            <div class="layui-input-inline" style="width: 100px">
                                <input type="number" name="code_height_limit" placeholder="输入数字"
                                       autocomplete="off" class="layui-input" min="0" style="line-height: 38px;"
                                       value="<?php echo $xiurr_code_config['code_height_limit']; ?>">
                            </div>
                            <div class="layui-input-inline">
                                <input type="checkbox" name="code_limit_btn" title="显示展开按钮" lay-skin="primary"
                                       lay-filter="btn_more" <?php echo $xiurr_code_config['code_limit_btn'] == 'on' ? 'checked' : ''; ?>>
                            </div>
                            <div class="layui-input-block layui-clear">
                                <div class="layui-form-mid layui-word-aux">单位是 px，直接添加数字，如 200</div>
                            </div>
                        </div>

                        <div class="layui-form-item">
                            <label class="layui-form-label">折叠状态</label>
                            <div class="layui-input-block">
                                <input type="checkbox" name="code_close" title="默认折叠" lay-skin="primary"
                                       value="code_close"
                                       lay-filter="btn_close" <?php echo $xiurr_code_config['code_close'] == 'on' ? 'checked' : ''; ?>>
                            </div>
                        </div>

                        <div class="layui-form-item layui-form-text">
                            <label class="layui-form-label">拓展样式</label>
                            <div class="layui-input-block">
                                    <textarea name="code_style" placeholder="请写入拓展CSS" rows="10"
                                              class="layui-textarea"><?php echo $xiurr_code_config['code_style']; ?></textarea>
                            </div>
                        </div>

                        <div class="layui-form-item">
                            <label class="layui-form-label">保留配置</label>
                            <div class="layui-input-inline">
                                <input type="radio" name="keep_config" value="on"
                                       title="保留" <?php echo $xiurr_code_config['keep_config'] == 'on' ? 'checked' : ''; ?>>
                                <input type="radio" name="keep_config" value="off"
                                       title="删除" <?php echo $xiurr_code_config['keep_config'] == 'off' ? 'checked' : ''; ?>>
                            </div>
                            <div class="layui-form-mid layui-word-aux">* 是否在停用或卸载插件后仍保留配置</div>
                        </div>

                        <div class="layui-form-item">
                            <div class="layui-input-block">
                                <button class="layui-btn" lay-submit lay-filter="formCode">立即提交</button>
                            </div>
                        </div>
                    </form>

                    <blockquote class="layui-elem-quote layui-quote-nm">
                        <h3>部分配置说明</h3>
                        <p>1. 代码换行勾选后不会出现横向滚动条</p>
                        <p>2. 高度限制为 0 或者为空时，表示显示全部代码，此时展开按钮无效</p>
                        <p>3. 高度限制大于 0 时，代码的长度未超出限定值，则按代码实际长度显示；长度超出限定值，则出现滚动条</p>
                        <p>4. 勾选展开按钮后，实际限制高度为 限高值 + 30 px ，多增加 30px 限制，目的是避免代码高度只超出限高值 一点时，出現展开按钮，展开没内容。</p>
                    </blockquote>
                </div>
                <div class="layui-col-md4" style="padding: 0 20px">
                    <div id="code-demo" style="margin-top: -25px">
                            <pre><code>
public function getCategory()
{
    if ($member_info['utype'] != 2) {
        throw new ApiException([
            'msg' => '您暂无权利使用该接口！',
            'errorCode' => 10003
        ]);
    }
    $return = $data->toArray();
}
            </code></pre>

                        <pre><code>
clip.on("success", function (e) {
    $(e.trigger).children().text("\ueb75").css('color', '#35cd4b');
    $(e.trigger).parent().find('.code-button-notice').text('复制成功').css('opacity', 1);
    clearTimeout(clickCopy);
    clickCopy = setTimeout(function () {
        $(e.trigger).children().text("\ueb4e").css('color', '');
        $(e.trigger).parent().find('.code-button-notice').css('opacity', '');
    }, 2000);
    e.clearSelection()
});
var hSetTimeKey = null;
$('input[name=code_height_limit]').keyup(function () {
    let value = $(this).val();
    clearTimeout(hSetTimeKey);
    hSetTimeKey = setTimeout(function () {
        xiurr_code_set_height(value, $('input[name=code_limit_btn]').is(':checked'));
    }, 300);
});
</code></pre>
                    </div>
                </div>
            </div>

        </div>
    </div>


    <script>
        window.XIURR_CODE_CONFIG = <?php echo $zbp->Config('xiurr_code')->config; ?>;
        var fileList = <?php echo json_encode($list_name); ?>;
    </script>

    <script type="text/javascript" src="assets/vendor/layui/layui.js"></script>
    <script type="text/javascript" src="assets/vendor/clipboard.min.js"></script>
    <script type="text/javascript" src="assets/vendor/jquery.dad.min.js"></script>
    <script type="text/javascript" src="assets/vendor/highlight.min.js"></script>
    <script type="text/javascript" src="assets/js/xiurr_code.js"></script>
    <script>
        layui.use(['layer', 'form'], function () {
            var layer = layui.layer
                , form = layui.form
                , demo = $('#code-demo');


            get_btn_input(window.XIURR_CODE_CONFIG.code_group_btn);

            $(".dash-box").dad();
            $(".dash-box").on("dadDragEnd", function (e, targetElement) {
                console.log(e, targetElement);
                // 重新渲染
                let code_group_btn = {};
                $('input[lay-filter="btn_setting"]').each(function () {
                    code_group_btn[$(this).val()] = $(this).prop('checked') ? 'on' : 'off';
                });
                let html = xiurr_code_get_btn(code_group_btn);
                $('.code-button-box').each(function () {
                    this.outerHTML = html;
                    // $(this).html(html);
                });
            })

            $('#highlight-style-box').click(function () {
                // 点击下拉框先记录原来的样式
                $(this).attr('s', $(this).find('select').val())
            }).keydown(function (e) {
                if (e.keyCode === 40 || e.keyCode === 38) {
                    // 键盘按上下
                    let val = $(this).find('dd.layui-this').attr('lay-value')
                        , str = $(this).find('dd.layui-this').text();
                    $(this).find('input').val(str);
                    $('#highlight-style').val(val);
                    change_style(val);
                } else if (e.keyCode === 27) {
                    // 按Esc进行样式还原
                    $(this).find('select').val($(this).attr('s'));
                    change_style($(this).attr('s'));
                    form.render();
                }
            });

            let op = '', first = '', def = '<?php echo $xiurr_code_config['highlight_style']; ?>';
            for (let i = 0, l = fileList.length; i < l; i++) {
                let t = fileList[i]['filename'].substr(0, 1), ht = '';
                if (first === '') {
                    first = t;
                    op += '<option value="">请选择样式</option><optgroup label="' + t.toUpperCase() + '">';
                }

                if (first !== t) {
                    first = t;
                    op += '</optgroup>';
                    op += '<optgroup label="' + t.toUpperCase() + '">';
                }

                ht = `<option value="${fileList[i]['path']}${fileList[i]['basename']}"` + (def === (fileList[i]['path'] + fileList[i]['basename']) ? 'selected' : '') + `>${i + 1}. ${fileList[i]['basename']}</option>`;
                op += ht;
            }
            op += '</optgroup>'
            $('#highlight-style').html(op);

            form.on('checkbox(class_setting)', function (data) {
                switch_class(data.elem.checked, data.value);
            });

            form.on('checkbox(btn_setting)', function (data) {
                if (data.elem.checked) {
                    demo.find('.code-wrapper .code-btn-' + data.value).removeClass('hide');
                } else {
                    demo.find('.code-wrapper .code-btn-' + data.value).addClass('hide');
                }
            });

            form.on('checkbox(btn_close)', function (data) {
                if (data.elem.checked) {
                    demo.find('.code-wrapper').attr('close', 'true').children('pre').css('max-height', '0').scrollTop(0);
                    // 折叠按钮默认开启
                    $('input[name=btn_close]').prop({'checked': true, 'disabled': true});
                    demo.find('.code-wrapper .code-btn-close').show();
                } else {
                    demo.find('.code-wrapper').attr('close', 'false').children('pre').css('max-height', '');
                    $('input[name=btn_close]').prop({'disabled': false});
                }
                form.render();
            });

            // 主题切换
            form.on('radio(border-style)', function (data) {
                let theme = '';
                $('input[lay-filter="border-style"]').each(function () {
                    theme += $(this).val() + ' ';
                });
                demo.find('.code-wrapper').removeClass(theme).addClass(data.value);
            });

            // 切换代码高亮
            form.on('select(highlight-style)', function (data) {
                change_style(data.value);
            });

            form.on('checkbox(btn_more)', function (data) {
                let height = $('input[name=code_height_limit]').val();
                xiurr_code_set_height(height, data.elem.checked);
            });

            // 高度限制设置
            var hSetTimeKey = null;
            $('input[name=code_height_limit]').keyup(function () {
                let value = $(this).val();
                clearTimeout(hSetTimeKey);
                hSetTimeKey = setTimeout(function () {
                    xiurr_code_set_height(value, $('input[name=code_limit_btn]').is(':checked'));
                }, 300);
            });

            // 表单赋值
            form.val("xiurr_code_form", {
                "border_style": window.XIURR_CODE_CONFIG.border_style
            });

            form.on('submit(formCode)', function (data) {
                let arr = data.field;
                arr.code_group_btn = {};
                $('input[lay-filter="btn_setting"]').each(function () {
                    arr.code_group_btn[$(this).val()] = $(this).prop('checked') ? 'on' : 'off';
                });
                // 默认折叠状态
                arr.code_close = arr.code_close ? 'on' : 'off';
                if (arr.code_close === 'on') {
                    arr.code_group_btn.close = 'on';
                }
                // 高度限制
                if (arr.code_height_limit === '') {
                    arr.code_height_limit = 0
                }
                // 展开按钮
                arr.code_limit_btn = arr.code_limit_btn ? 'on' : 'off';

                // console.log(arr);return false;
                $.ajax({
                    type: "POST",
                    url: "./php/config.php?action=save",
                    data: data.field,
                    dataType: "json",
                    success: function (result) {
                        layer.open({
                            title: '操作提示',
                            icon: result.code === 1 ? 6 : 5,
                            content: result.message,
                            shadeClose: true,
                            yes: function (index) {
                                layer.close(index);
                            }
                        });
                    }
                });
                return false; // 阻止表单跳转。如果需要表单跳转，去掉这段即可。
            });

            form.render();

            // 渲染按钮组
            function get_btn_input(data) {
                let dash_html = '', title = '', checked = false, name = '';
                for (let k in data) {
                    dash_html += '<li class="dash-btn">', checked = data[k] === 'on' ? 'checked' : '';
                    if (k === 'full') {
                        name = 'btn_full', title = '全屏按钮';
                    }
                    if (k === 'copy') {
                        name = 'btn_copy', title = '复制按钮';
                    }
                    if (k === 'close') {
                        name = 'btn_close', title = '折叠按钮';
                    }
                    dash_html += '<input type="checkbox" name="' + name + '" title="' + title + '" lay-skin="primary" value="' + k + '" lay-filter="btn_setting" ' + checked + '>';
                    dash_html += '</li>';
                }
                $('.dash-box').html(dash_html);
            }

            function xiurr_code_set_height(val, more) {
                demo.find('pre').css('height', '');
                if (val !== '') {
                    val = parseInt(val);
                    $('.code-btn-expand').remove();
                    demo.find('pre').each(function () {
                        if (val > 0 && $(this).height() > val + 30) {
                            if (more) {
                                $(this).before('<div class="code-btn-expand"><i class="code-iconfont">&#xeb04;</i></div>');
                                $(this).css('height', val);
                            } else {
                                $(this).css('height', val);
                            }
                        }
                    });
                }
            }

            // 样式设置
            function change_style(value) {
                $('#xiurr_css_href').attr('href', "./assets/css/highlight/" + value);
            }

            // 切换code-wrapper的样式
            function switch_class(checked, value) {
                if (checked) {
                    demo.find('.code-wrapper').addClass(value);
                } else {
                    demo.find('.code-wrapper').removeClass(value);
                }
            }

        });

    </script>

<?php
require $blogpath . 'zb_system/admin/admin_footer.php';
RunTime();
?>