<?php 
$seoTitle = $cfg->seoTitle;
$seoKeywords = $cfg->seoKeywords;
$seoDescription = $cfg->seoDescription;
$seoSeparator = $cfg->seoSeparator ? $cfg->seoSeparator : ' - ';
if($type == 'index'){
    if($page == '1'){
        if(isset($seoTitle) && !empty($seoTitle)){
            $pageTitle = $seoTitle;
        }else{
            $pageTitle = $zbp->name.$seoSeparator.$zbp->subname;
        }
    }else{
        $pageTitle = '第'.$page.'页'.$seoSeparator.$zbp->name;
    }
    if(isset($seoKeywords)){
        $keywords = $seoKeywords;
    }else{
        $keywords = '';
    }
    if(isset($seoDescription)){
        $description = $seoDescription;
    }else{
        $description = '';
    }
}elseif($type == 'category'){
    $cate_array = array(
        'cata' => $zbp->title,
        'title' => $zbp->name,
        'subtitle' => $zbp->subname,
    );
    $cate_info = json_decode($cfg->seoCate,true);
    $cateTitle = '';
    if(count((array)$cate_info)){
        foreach($cate_info as $key => $info){
            if($info == 1) $cate_newname[] = $cate_array[$key];
        }
        $cateTitle .= implode($seoSeparator, $cate_newname);
    }else{
        $cateTitle .= $zbp->title.$seoSeparator.$zbp->name;
    }
    if ($page == '1') {
        $pageTitle = $cateTitle;
    }else{
        $pageTitle = $zbp->title.$seoSeparator.$zbp->name;
    }
    $keywords = $category->Name;
    $description = $category->Intro;
    
    }elseif($type == 'tag'){
        $tag_array = array(
            'tag' => $zbp->title,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $tag_info = json_decode($cfg->seoTag,true);
        $tagTitle = '';
        if(count((array)$tag_info)){
            foreach($tag_info as $key => $info){
                if($info == 1) $tag_newname[] = $tag_array[$key];
            }
            $tagTitle .= implode($seoSeparator, $tag_newname);
        }else{
            $tagTitle .= $zbp->title.$seoSeparator.$zbp->name;
        }
        if ($page=='1') {
            $pageTitle = $tagTitle;
        }else{
            $pageTitle = $zbp->title.$seoSeparator.$zbp->name;
        }
        $keywords = $tag->Name;
        $description = $tag->Intro;
    }elseif($type == 'article'){
        $article_array = array(
            'article' => $article->Title,
            'cata' => $article->Category->Name,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $article_info = json_decode($cfg->seoArticle,true);
        $articleTitle = '';
        if(count((array)$article_info)){
            foreach($article_info as $key => $info){
                if($info == 1) $article_newname[] = $article_array[$key];
            }
            $articleTitle .= implode($seoSeparator, $article_newname);
        }else{
            $articleTitle .= $zbp->title.$seoSeparator.$zbp->name;
        }
        $pageTitle = $articleTitle;
        
        $aryTags = array();
        foreach($article->Tags as $key){
            $aryTags[] = $key->Name;
        }
        if(count($aryTags)>0){
            $keywords = implode(',',$aryTags);
        }else{
            $keywords = '';
        }
        $description = ($article->Intro !== '') ? $article->Intro : preg_replace('/[\r\n\s]+/', '', trim(SubStrUTF8(TransferHTML($article->Content,'[nohtml]'),200)).'...');
    }elseif($type == 'page'){
        $page_array = array(
            'page' => $article->Title,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $page_info = json_decode($cfg->seoPage,true);
        $pageTitle = '';
        if(count((array)$page_info)){
            foreach($page_info as $key => $info){
                if($info == 1) $page_newname[] = $page_array[$key];
            }
            $pageTitle .= implode($seoSeparator, $page_newname);
        }else{
            $pageTitle .= $zbp->title.$seoSeparator.$zbp->name;
        }
        $pageTitle = $pageTitle;
        $keywords = '';
        $description = preg_replace('/[\r\n\s]+/', '', trim(SubStrUTF8(TransferHTML($article->Content,'[nohtml]'),200)).'...');
    }elseif($type == 'author'){
        $user_array = array(
            'user' => $title,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $user_info = json_decode($cfg->seoUser,true);
        $userTitle = '';
        if(count((array)$user_info)){
            foreach($user_info as $key => $info){
                if($info == 1) $user_newname[] = $user_array[$key];
            }
            $userTitle .= implode($seoSeparator, $user_newname);
        }else{
            $userTitle .= $zbp->title.$seoSeparator.$zbp->name;
        }
        $pageTitle = $userTitle;
        if(isset($seoKeywords)){
            $keywords = $seoKeywords;
        }else{
            $keywords = '';
        }
        if(isset($seoDescription)){
            $description = $seoDescription;
        }else{
            $description = '';
        }
    }elseif($type == 'date'){
        $date_array = array(
            'date' => $title,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $date_info = json_decode($cfg->seoData,true);
        $dateTitle = '';
        if(count((array)$date_info)){
            foreach($date_info as $key => $info){
                if($info == 1) $date_newname[] = $date_array[$key];
            }
            $dateTitle .= implode($seoSeparator, $date_newname);
        }else{
            $dateTitle .= $zbp->title.$seoSeparator.$zbp->name;
        }
        $pageTitle = $dateTitle;
        if(isset($seoKeywords)){
            $keywords = $seoKeywords;
        }else{
            $keywords = '';
        }
        if(isset($seoDescription)){
            $description = $seoDescription;
        }else{
            $description = '';
        }
    }elseif($type == 'search'){
        $search_array = array(
            'search' => $title,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $search_info = json_decode($cfg->seoSearch,true);
        $searchTitle = '';
        if(count((array)$search_info)){
            foreach($search_info as $key => $info){
                if($info == 1) $search_newname[] = $search_array[$key];
            }
            $searchTitle .= implode($seoSeparator, $search_newname);
        }else{
            $searchTitle .= $zbp->title . $seoSeparator . $zbp->name;
        }
        $pageTitle = $searchTitle;
        if(isset($seoKeywords)){
            $keywords = $seoKeywords;
        }else{
            $keywords = '';
        }
        if(isset($seoDescription)){
            $description = $seoDescription;
        }else{
            $description = '';
        }
    }else{
        $other_array = array(
            'other' => $title,
            'title' => $zbp->name,
            'subtitle' => $zbp->subname,
        );
        $other_info = json_decode($cfg->seoOther,true);
        $otherTitle = '';
        if(count((array)$other_info)){
            foreach($other_info as $key => $info){
                if($info == 1) $other_newname[] = $other_array[$key];
            }
            $otherTitle .= implode($seoSeparator, $other_newname);
        }else{
            $otherTitle .= $zbp->title . $seoSeparator . $zbp->name;
        }
        if($page > '1'){
            $pageTitle = $zbp->title . $seoSeparator . $zbp->name;
        }else{
            $pageTitle = $otherTitle;
        }
        if(isset($seoKeywords)){
            $keywords = $seoKeywords;
        }else{
            $keywords = '';
        }
        if(isset($seoDescription)){
            $description = $seoDescription;
        }else{
            $description = '';
        }
    }
 ?>
    <title><?php  echo $pageTitle;  ?></title>
<?php if (!empty($keywords)) { ?>
    <meta name="keywords" content="<?php  echo $keywords;  ?>">
<?php } ?>
<?php if (!empty($description)) { ?>
    <meta name="description" content="<?php  echo $description;  ?>">
<?php } ?>