<style>
.container {
    width: 8em;
    height: 1em;
    font-size: 35px;
    display: flex;
    justify-content: space-between;
}

.container span {
    width: 1em;
    height: 1em;
    --duration: 1.5s;
}

.girl {
    animation: slide var(--duration) ease-in-out infinite alternate;
}

@keyframes slide {
    from {
        transform: translateX(0);
        filter: brightness(1);
    }

    to {
        transform: translatex(calc(8em - (1em * 1.25)));
        filter: brightness(1.45);
    }
}

.boys {
    width: 6em;
    display: flex;
    justify-content: space-between;
}

.boys span {
    animation: var(--duration) ease-in-out infinite alternate;
}

.boys span:nth-child(1) {
    animation-name: jump-off-1;
}

.boys span:nth-child(2) {
    animation-name: jump-off-2;
}

.boys span:nth-child(3) {
    animation-name: jump-off-3;
}

.boys span:nth-child(4) {
    animation-name: jump-off-4;
}

@keyframes jump-off-1 {
    0%, 15% {
        transform: rotate(0deg);
    }

    35%, 100% {
        transform-origin: -50% center;
        transform: rotate(-180deg);
    }
}

@keyframes jump-off-2 {
    0%, 30% {
        transform: rotate(0deg);
    }

    50%, 100% {
        transform-origin: -50% center;
        transform: rotate(-180deg);
    }
}

@keyframes jump-off-3 {
    0%, 45% {
        transform: rotate(0deg);
    }

    65%, 100% {
        transform-origin: -50% center;
        transform: rotate(-180deg);
    }
}

@keyframes jump-off-4 {
    0%, 60% {
        transform: rotate(0deg);
    }

    80%, 100% {
        transform-origin: -50% center;
        transform: rotate(-180deg);
    }
}

.container span::before {    
    content: '';
    position: absolute;
    width: inherit;
    height: inherit;
    border-radius: 15%;
    box-shadow: 0 0 0.1em rgba(0, 0, 0, 0.3);
}

.girl::before {
    background-color: hotpink;
}

.boys span::before {
    background-color: dodgerblue;
    animation: var(--duration) ease-in-out infinite alternate;
}

.boys span:nth-child(1)::before {
    content: '菜';
    font-size: .8em;
    text-align: center;
    color: #fff;
    filter: brightness(1);
    animation-name: jump-down-1;
}

.boys span:nth-child(2)::before {
    content: '鸟';
    font-size: .8em;
    text-align: center;
    color: #fff;
    filter: brightness(1.15);
    animation-name: jump-down-2;
}

.boys span:nth-child(3)::before {
    content: '建';
    font-size: .8em;
    text-align: center;
    color: #fff;
    filter: brightness(1.3);
    animation-name: jump-down-3;
}

.boys span:nth-child(4)::before {
    content: '站';
    font-size: .8em;
    text-align: center;
    color: #fff;
    filter: brightness(1.45);
    animation-name: jump-down-4;
}

@keyframes jump-down-1 {
    5% {
        transform: scale(1, 1);
    }

    15% {
        transform-origin: center bottom;
        transform: scale(1.3, 0.7);
    }

    20%, 25% {
        transform-origin: center bottom;
        transform: scale(0.8, 1.4);
    }

    40% {
        transform-origin: center top;
        transform: scale(1.3, 0.7);
    }

    55%, 100% {
        transform: scale(1, 1);
    }
}

@keyframes jump-down-2 {
    20% {
        transform: scale(1, 1);
    }

    30% {
        transform-origin: center bottom;
        transform: scale(1.3, 0.7);
    }

    35%, 40% {
        transform-origin: center bottom;
        transform: scale(0.8, 1.4);
    }

    55% {
        transform-origin: center top;
        transform: scale(1.3, 0.7);
    }

    70%, 100% {
        transform: scale(1, 1);
    }
}

@keyframes jump-down-3 {
    35% {
        transform: scale(1, 1);
    }

    45% {
        transform-origin: center bottom;
        transform: scale(1.3, 0.7);
    }

    50%, 55% {
        transform-origin: center bottom;
        transform: scale(0.8, 1.4);
    }

    70% {
        transform-origin: center top;
        transform: scale(1.3, 0.7);
    }

    85%, 100% {
        transform: scale(1, 1);
    }
}

@keyframes jump-down-4 {
    50% {
        transform: scale(1, 1);
    }

    60% {
        transform-origin: center bottom;
        transform: scale(1.3, 0.7);
    }

    65%, 70% {
        transform-origin: center bottom;
        transform: scale(0.8, 1.4);
    }

    85% {
        transform-origin: center top;
        transform: scale(1.3, 0.7);
    }

    100%, 100% {
        transform: scale(1, 1);
    }
}   
</style>
<div id="div-module">
	<div id="div-progress" style="display:none;">
	    <div class="container">
	        <span class="girl"></span>
	        <div class="boys">
	            <span></span>
	            <span></span>
	            <span></span>
	            <span></span>
	       </div>
	   </div>
	</div>
    <p></p>
    <div id="div-message">
    	<table class="table_border table_border_cells table_striped table_hover" style="width:100%">
		<tbody id="tbody-message">
        <tr><td>正在初始化</td></tr>
        </tbody>
        </table>
    </div>
</div>

<script type="text/javascript">
var sweetTitles = {
	x: 10,
	y: 20,
	tipElements: "span,div ",
	noTitle: false,
	init: function() {
		var noTitle = this.noTitle;
		$(this.tipElements).each(function() {
			$(this).mouseover(function(e) {
				if (noTitle) {
					isTitle = true;
				} else {
					isTitle = $.trim(this.title) != '';
				}
				if (isTitle) {
					this.myTitle = this.title;
					this.title = "";
					var tooltip =
						"<div class='tooltip'><div class='tipsy-arrow tipsy-arrow-n'></div><div class='tipsy-inner'>" + this.myTitle +
						"</div></div>";
					$('body').append(tooltip);
					$('.tooltip').css({
						"top": (e.pageY + 20) + "px",
						"left": (e.pageX - 20) + "px"
					}).show('fast');
				}
			}).mouseout(function() {
				if (this.myTitle != null) {
					this.title = this.myTitle;
					$('.tooltip').remove();
				}
			}).mousemove(function(e) {
				$('.tooltip').css({
					"top": (e.pageY + 20) + "px",
					"left": (e.pageX - 20) + "px"
				});
			});
		});
	}
};
</script>
<script type="text/javascript">
var $tableSelector = $("#tbody-message");
var $progress = $("#div-progress");
$.xhrPool = [];
$.xhrPool.abortAll = function() {
    $(this).each(function(idx, jqXHR) {
        jqXHR.abort();
    });
    $.xhrPool = [];
};

$.ajaxSetup({
    beforeSend: function(jqXHR) {
        $.xhrPool.push(jqXHR);
    },
    complete: function(jqXHR) {
        var index = $.xhrPool.indexOf(jqXHR);
        if (index > -1) {
            $.xhrPool.splice(index, 1);
        }
    }
});

var pushConfig = {
	moduleId: "<?php echo $module?>",
    maxTasks: 0,
    currentTask: 0,
    currentTime: 0,
    timeInterval: 0
};
var ajaxPost = function(param) {
    var url = "ajax.php?suc=<?php echo $suc?>&module=" + pushConfig.moduleId + "&ids=<?php echo $ids?>";
    var ajax = $.ajax(url, {
        data: param,
        type: "POST",
        dataType: "json",
        <?php if($async == '1'){echo 'async: false';}?>
    });
    return new Promise(function(resolve, reject) {
        ajax.done(resolve).fail(reject);
        //console.log(this);
    })
};
var sendMessage = function(textString) {
    $("<tr><td>" + textString + "</td></tr>").prependTo($tableSelector);
};
var sleep = function(numberMillis) {
    var now = new Date();
    var exitTime = now.getTime() + numberMillis;
    while(true) {
        now = new Date();
        if (now.getTime() > exitTime)
        return;
    }
};
$(function() {
    $progress.show();
    var addTask = function(data) {
        pushConfig.maxTasks += data.length;
        return Promise.map(data, function(item, index) {
            //this.sleep(1000);
            //console.log(item);
            pushConfig.currentTask++;
            console.log(Date.now() + " timeout call back");
            return ajaxPost(item).then(function(data) {
                return Promise.map(data, function(item) {
                    if (item.type == "msg") {
                        sendMessage(item.msg);
                    } else {
                        task.then(function() {
                            return addTask([item]);
                        });
                    }
                });
            });
        }).then(function(data) {
            $progress.hide();
            sweetTitles.init();
            sendMessage('<span style="color: green">任务执行完毕(任务列表)</span>');
        });
    };

    var task = ajaxPost({function: "get_queue"}).cancellable().then(addTask).error(function(e) {
        var errorMessage = e.responseText.replace(/\</g, '&lt;').replace(/\>/g, '&gt;').split("\n").reverse();
        errorMessage.forEach(function(item) {
            sendMessage(item);
        });
        sendMessage('错误状态码：' + e.status);
        sendMessage('<span style="color: red">× 执行过程中出现错误！</span>');
        $.xhrPool.abortAll();
    });

});
</script>
