<?php
require dirname(__FILE__) . DIRECTORY_SEPARATOR . 'mavatar/Multiavatar.php';

#注册插件
RegisterPlugin("Jz52_multiavatar","ActivePlugin_Jz52_multiavatar");

function ActivePlugin_Jz52_multiavatar() {
	global $zbp;
	Add_Filter_Plugin('Filter_Plugin_Member_Avatar', 'Jz52_multiavatar_QQMultiavatar'); 
}

#头像
function Jz52_multiavatar_QQMultiavatar(&$member) {
	global $zbp;
	if($zbp->Config('Jz52_multiavatar')->api){
		if($zbp->Config('Jz52_multiavatar')->jt){
			$local_rg = Jz52_multiavatar_svgurl($member->StaticName);
		}else{
			$local_rg = $zbp->host.'zb_users/plugin/Jz52_multiavatar/mavatar/?u='.$member->StaticName.'&t='.$zbp->GetCSRFToken("Jz52_multiavatar");
		}
	}else{
		$key=$zbp->Config('Jz52_multiavatar')->mkey?$zbp->Config('Jz52_multiavatar')->mkey:'yeelz';
	    $ub=Jz52_multiavatar_encrypt($member->StaticName, $key);
		if($zbp->Config('Jz52_multiavatar')->svgapi){
			$local_rg = 'https://api.multiavatar.com/'.$ub.'.svg';
		}else{
			$local_rg = 'https://api.multiavatar.com/'.$ub.'.png';
		}
	}
	preg_match_all( '/((\d)*)@qq.com/', $member->Email, $vai );
	if ($member->ID > 0 && $zbp->Config('Jz52_multiavatar')->userid) {
		if (is_file($zbp->usersdir . 'avatar/' . $member->ID . '.png')) {
			$url =  $zbp->host . 'zb_users/avatar/' . $member->ID . '.png';
		}else{
			if ( !empty( $vai[ '1' ][ '0' ] ) && $zbp->Config('Jz52_multiavatar')->qqemail ) {
				$url = 'https://q1.qlogo.cn/g?b=qq&nk=' . $vai[ '1' ][ '0' ] . '&s=640';
			} else {
				$url = $local_rg;
			}
		}
	}else{
		if ( !empty( $vai[ '1' ][ '0' ] ) && $zbp->Config('Jz52_multiavatar')->qqemail ) {
			$url = 'https://q1.qlogo.cn/g?b=qq&nk=' . $vai[ '1' ][ '0' ] . '&s=640';
		} else {
			$url = $local_rg;
		}
	}
	return $url;
}


#目录生成
function Jz52_multiavatar_create_folders($dir) { 
	global $blogpath;
	return is_dir($dir) or (Jz52_multiavatar_create_folders(dirname($dir)) and mkdir($dir, 0777) and @file_put_contents($blogpath.'zb_users/plugin/Jz52_multiavatar/mavatar/svg/index.html','')); 
}

#文件生成
function Jz52_multiavatar_svgurl($u) {
	global $zbp, $blogpath;
	$key=$zbp->Config('Jz52_multiavatar')->mkey?$zbp->Config('Jz52_multiavatar')->mkey:'yeelz';
	$ub=Jz52_multiavatar_encrypt($u, $key);
	$filename=$blogpath.'zb_users/plugin/Jz52_multiavatar/mavatar/svg/'.$ub.'.svg';
	$hostdir = $blogpath.'zb_users/plugin/Jz52_multiavatar/mavatar/svg/';
	$url='';
	if(file_exists($filename)){
		$url=$zbp->host.'zb_users/plugin/Jz52_multiavatar/mavatar/svg/'.$ub.'.svg';
	}else{
		Jz52_multiavatar_create_folders($hostdir);
		$multiavatar = new Jz52_multiavatar_Multiavatar($u, null, null);
		@file_put_contents($filename,$multiavatar->svgCode);
		$url=$zbp->host.'zb_users/plugin/Jz52_multiavatar/mavatar/svg/'.$ub.'.svg';
	}
	return 	$url;	
}

#编码
function Jz52_multiavatar_encrypt($data, $key)  {  
    $char="";
    $str="";
    $key    =   md5($key);  
    $x      =   0;  
    $len    =   strlen($data);  
    $l      =   strlen($key);  
    for ($i = 0; $i < $len; $i++) {  
        if ($x == $l) { $x = 0; }  
        $char .= $key[$x];  
        $x++;  
    }  
    for ($i = 0; $i < $len; $i++){  
        $str .= chr(ord($data[$i]) + (ord($char[$i])) % 256);  
    }  
	return strtr(base64_encode($str), '+/=', '-_,');
} 


function InstallPlugin_Jz52_multiavatar() {}
function UninstallPlugin_Jz52_multiavatar() {
	global $zbp;
	if ( $zbp->Config('Jz52_multiavatar')->DelCon ) {
		$zbp->DelConfig('Jz52_multiavatar');
	}
}